#include "fsadm.h"
#include <sys/types.h>
#include <sys/termio.h>
#include <sys/ioctl.h>
#include <signal.h>

short language;
char *backup;
short msg = 0;
char *msgtab[][NL] = {
  {"", ""},
  {"%s", "%s"},
  {"The pool is empty", "Poolen {r tom"},
  {"Filename:", "Filnamn:"},
  {"Can't copy a directory", "Kan ej kopiera ett bibliotek"},
  {"You are at root", "Du har n}tt 'root'"},
  {"%s already exists", "%s finns redan"},
  {"Can't change directory", "Kan ej byta bibliotek"},
  {"Can't open %s", "Kan ej |ppna %s"},
  {"Can't display %s", "Kan ej visa %s"},
  {"Can't copy %s", "Kan ej kopiera %s"},
  {"Can't move %s", "Kan ej flytta %s"},
  {"Can't remove %s", "Kan ej radera %s"},
  {"Can't link %s", "Kan ej l{nka %s"},
  {"Can't create %s", "Kan ej skapa %s"},
  {"Can't change mode for %s", "Kan ej byta filskydd f|r %s"},
  {"Can't backup", "Kan ej skyddskopiera"},
  {"%s not empty", "%s ej tomt"},
  {"Insert disk/tape in %s", "S{tt i disk/band i %s"},
  {"Can't access %s", "Hittar ej %s"},
  {"You can't operate on %s", "Du kan inte operera p} %s"},
  {"Protection violation", "Du har inte tillr{ckliga r{ttighter"}
};


getch(stay)
register short stay;
{
  register int c;

  while ((c = getchar()) == -1 && stay);
  return(c);
}

refresh(f)
short f;
{
  extern draw();

  signal(SIGUSR1, f ? draw : SIG_IGN);
}

interupt(f)
short f;
{
  extern goodbye();

  signal(SIGINT, f ? goodbye : SIG_IGN);
}

setraw(fd, f)
int fd, f;
{
  struct termio tty;

  if (f) {
    ioctl(fd, TCGETA, &tty);
    tty.c_lflag &= ~(ICANON | ECHO);
    ioctl(fd, TCSETA, &tty);
  }
  else {
    ioctl(fd, TCGETA, &tty);
    tty.c_lflag |= (ICANON | ECHO);
    ioctl(fd, TCSETA, &tty);
  }
}

panic(arg1, arg2)
char *arg1, *arg2;
{
  print("\007\033cfsadm: ");
  print(arg1, arg2);
  flush(STDERR);
  sleep(10);
  goodbye();
}

message(msgno, arg)
short msgno;
char *arg;
{
  int wfd;

  if ((wfd = mkwin(100, 100, 350, 85)) == -1) panic("Can't open window");
  print("\033:0;0;0;0;%d;%d;1r", 350, 85);
  print("\033:4;4;4;4;%d;%d;1r", 342, 77);
  print("\033[2;2H");
  print(msgtab[msgno][language], arg);
  flush(wfd);
  ok(wfd);
  close(wfd);
}

ok(wfd)
int wfd;
{
  char c;

  print("\033:305;10m");
  print("\033:335;10;;1d\033:340;15;;1d");
  print("\033:340;30;;1d\033:335;35;;1d");
  print("\033:305;35;;1d\033:300;30;;1d");
  print("\033:300;15;;1d\033:305;10;;1d");
  print("\033:312;15m\033:1HOK");
  flush(wfd);
  wd_icon(wfd, 300, 10, 40, 25, " ", 0);
  while(read(wfd, &c, 1), c != ' ');
}

more(wfd, prompt)
int wfd;
char *prompt;
{
  int n, c;

  print("\033[7m%s\033[0m", prompt);
  flush(wfd);
  read(wfd, &c, 1);
  print("\015\033[K");
  flush(wfd);
  return(WR-3);
}

char *getfname(ofn)
char *ofn;
{
  int wfd;
  short n = 0;
  char c;
  static char fnbuf[NC+1];
  static char *legal[NL] = {
"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789._+-,#%",
"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789._+-,#%}{|][\\"
  };

  if ((wfd = mkwin(100,100,40*FW,6*FH)) == -1) panic("Can't open window");
  print("\033:0;0;0;0;%d;%d;1r", 40*FW, 6*FH);
  print("\033:4;4;4;4;%d;%d;1r", 40*FW-8, 6*FH-8);
  print("\033[?35l\033[2;2H");
  if (ofn) print(msgtab[6][language], ofn);
  print("\033[4;2H%s", msgtab[3][language]);

  print("\033:26;7m\033:157;7;;1d\033:157;26;;1d");
  print("\033:26;26;;1d\033:26;7;;1d");

  print("\033:305;10m");
  print("\033:335;10;;1d\033:340;15;;1d");
  print("\033:340;30;;1d\033:335;35;;1d");
  print("\033:305;35;;1d\033:300;30;;1d");
  print("\033:300;15;;1d\033:305;10;;1d");
  print("\033:312;15m\033:1HOK");
  print("\033:29;10m\033:1H");
  flush(wfd);
  wd_icon(wfd, 300, 10, 40, 25, "\n", 0);
  while (read(wfd, &c, 1), c != '\n' || !n) {
    if (strchr(legal[language], c)) {
      if (n < NC) {
        fnbuf[n++] = c;
        print("%c", c);
      }
      else BELL;
    }
    else if (c == '\010' && n) {
      n--;
      print("\010 \010");
    }
    else BELL;
    flush(wfd);
  }
  fnbuf[n] = '\0';
  close(wfd);
  return(fnbuf);
}

setlanguage()
{
  char *l, *getenv();

  if ((l = getenv("LANGUAGE")) == NULL) {
    l = "english"; /* default language */
  }
  if (!strcmp(l, "swedish")) {
    language = 1;
    print("\033(H");
  }
  else {
    language = 0;
    print("\033(I");
  }
  flush(STDOUT);
}

setbackup()
{
  char *b, *getenv(), *strdup();

  if ((b = getenv("BACKUP")) == NULL) backup = "/dev/mf2";
  else backup = strdup(b);
}
