#include "fsadm.h"

extern char *backup;


do_more()
{
  int wfd;
  register short ix;
  short getftype();

  refresh(OFF);
  if ((wfd = mkwin(0, 0, WC*FW, WR*FH)) == -1) return;
  wd_icon(wfd, 0, 0, WC*FW, WR*FH, " ", 0);
  for (ix = 0; ix < port[POOL].cnt; ix++) {
    if (getftype(ix) == DIRS) continue;
    cat(wfd, port[POOL].path[ix]);
    if ((ix+1) < port[POOL].cnt) more(wfd, "-- next file --");
    else more(wfd, "-- the end --");
  }
  refresh(ON);
  close(wfd);
}

do_cp()
{
  register short ix, ft;
  char *fn, *getfname();

  for (ix = 0; ix < port[POOL].cnt; ix++) {
    if ((ft = getftype(ix)) == -1) {
      message(19, port[POOL].path[ix]);
      continue;
    }
    if (ft == DIRS) {
      message(4);
      continue;
    }
    if (access(port[POOL].name[ix], 00) == -1) fn = port[POOL].name[ix];
    else {
      while (access(fn = getfname(port[POOL].name[ix]), 00) == 0) message(6, fn);
    }
    if (cp(port[POOL].path[ix], fn)) add_to_port(ft, fn);
    else message(10, port[POOL].path[ix]);
  }
}

do_mv()
{
  register short ix, ft;
  char *fn;

  for (ix = 0; ix < port[POOL].cnt; ix++) {
    if ((ft = getftype(ix)) == -1) {
      message(19, port[POOL].path[ix]);
      continue;
    }
    if (access(port[POOL].name[ix], 0) == -1) fn = port[POOL].name[ix];
    else {
      while (access(fn = getfname(port[POOL].name[ix]), 00) == 0) message(6, fn);
    }
    if (ft ? mvdir(port[POOL].path[ix], fn) : mv(port[POOL].path[ix], fn)) {
      if (incwd(ix)) sub_fr_port(ft, lookup(ft, ix));
      add_to_port(ft, fn);
    }
    else message(11, port[POOL].path[ix]);
  }
}

do_rm()
{
  register short ix, ft;

  for (ix = 0; ix < port[POOL].cnt; ix++) {
    if ((ft = getftype(ix)) == -1) {
      message(19, port[POOL].path[ix]);
      continue;
    }
    if (ft ? rmdir(port[POOL].path[ix]) : rm(port[POOL].path[ix])) {
      if (incwd(ix)) sub_fr_port(ft, lookup(ft, ix));
    }
    else message(12, port[POOL].path[ix]);
  }
}

do_ln()
{
  register short ix, ft;
  char *fn;

  for (ix = 0; ix < port[POOL].cnt; ix++) {
    if ((ft = getftype(ix)) == -1) {
      message(19, port[POOL].path[ix]);
      continue;
    }
    while (access(fn = getfname(NULL), 00) == 0) message(6, fn);
    if (link(port[POOL].path[ix], fn) == -1) {
      message(13, port[POOL].path[ix]);
      continue;
    }
    add_to_port(ft, fn);
  }
}

do_mkdir()
{
  char *fn, *p;
  int pid, status;

  if (access(".", 02) == -1) {
    message(21);
    return;
  }
  while (access(fn = getfname(NULL), 00) == 0) message(6, fn);
  if ((pid = fork()) == 0) {
    execl("/usr/bryte/bin/mkdir", "fsadm", fn, NULL);
    panic("Can't execute mkdir");
  }
  while (wait(&status) != pid);
  if (status) message(status>>8, fn);
  else add_to_port(DIRS, fn);
}

do_chmod()
{
  int wfd;
  register short ix, m;
  short getfmode(), changemode();

  if ((wfd = mkwin(100, 100, 20*FW, 6*FH)) == -1) return;
  print("\033:0;0;0;0;%d;%d;1r", 20*FW, 6*FH);
  print("\033:4;4;4;4;%d;%d;1r", 20*FW-8, 6*FH-8);
  chmodeicons(wfd);
  for (ix = 0; ix < port[POOL].cnt; ix++) {
    if ((m = getfmode(ix)) == -1) continue;
    chmod(port[POOL].path[ix], changemode(wfd, port[POOL].name[ix], m));
  }
  close(wfd);
}

do_tarc()
{
  register int wfd;
  register short ix;
  register char **argv;
  char *strdup(), *alloc();
  int status;

  message(18, backup);
  if (fork() == 0) {
    if ((wfd = mkwin(100, 100, 40*FW, 12*FH)) == -1) exit(0);
    close(STDIN); close(STDOUT); close(STDERR);
    dup(wfd); dup(wfd); dup(wfd);
    chdir("/");
    argv = (char **)alloc((port[POOL].cnt + 3) * sizeof(char *));
    argv[0] = "tar";
    argv[1] = "cvf";
    argv[2] = backup;
    for (ix = 0; ix < port[POOL].cnt; ix++) {
      argv[ix + 3] = strdup(port[POOL].path[ix]+1);
    }
    argv[ix + 3] = NULL;
    execv("/bin/tar", argv);
    panic("Can't execute /bin/tar");
  }
  wait(&status);
}

do_tarx()
{
  register int wfd;
  int status;

  message(18, backup);
  if (fork() == 0) {
    if ((wfd = mkwin(100, 100, 40*FW, 12*FH)) == -1) exit(1);
    close(STDIN); close(STDOUT); close(STDERR);
    dup(wfd); dup(wfd); dup(wfd);
    chdir("/");
    execl("/bin/tar", "tar", "xvf", backup, NULL);
    panic("Can't execute /bin/tar");
  }
  wait(&status);
  readdir();
  printport(FILES);
  printport(DIRS);
}
