#include "fsadm.h"
#include <fcntl.h>
#define BUFSIZ 512


cat(wfd, pn)
int wfd;
char *pn;
{
  int fd;
  char buf[BUFSIZ];
  register short nlcnt, n;
  register char *p, *bp;

  if ((fd = open(pn, O_RDONLY)) == -1) return(0);
  n = strlen(pn) + 2;
  print("\033[7m%*s\n %s \n%*s\033[0m\n", n, "", pn, n, "");
  flush(wfd);
  nlcnt = WR-4;
  while ((n = read(fd, buf, BUFSIZ)) > 0) {
    bp = buf;
    for (p = buf; (p - buf) < BUFSIZ; p++) {
      if (*p == '\n' && !(--nlcnt)) {
        write(wfd, bp, p+1-bp);
        n -= p+1-bp;
        bp = p+1;
        nlcnt = more(wfd, "--more--");
      }
    }
    write(wfd, bp, n);
  }
  if (*(bp+n-1) != '\n') write(wfd, '\n', 1);
  close(fd);
  return(1);
}

cp(spn, dfn)
char *spn, *dfn;
{
  register int sfd, dfd, n;
  register char buf[BUFSIZ];

  if ((sfd = open(spn, O_RDONLY)) == -1) return(0);
  if ((dfd = open(dfn, O_WRONLY | O_CREAT | O_EXCL, 0777)) == -1) return(0);
  while ((n = read(sfd, buf, BUFSIZ)) > 0) write(dfd, buf, n);
  close(sfd);
  close(dfd);
  return(1);
}

mv(spn, dfn)
register char *spn, *dfn;
{
  if (link(spn, dfn) == -1) return(0);
  if (unlink(spn) == -1) {
    unlink(dfn);
    return(0);
  }
  return(1);
}

mvdir(spn, dfn)
char *spn, *dfn;
{
  int pid, status;
  register char *p;

  for (p = spn+strlen(spn); *p != '/'; p--);
  *p = '\0';
  if (access(spn, 02) == -1) {
    message(21);
    *p = '/';
    return(0);
  }
  *p = '/';
  if (access(".", 02) == -1) {
    message(21);
    return(0);
  }
  if ((pid = fork()) == 0) {
    execl("/usr/bryte/bin/mvdir", "fsadm", spn, dfn, NULL);
    panic("Can't execute mvdir");
  }
  while (wait(&status) != pid);
  if (status) message(status>>8, spn);
  return(!status);
}

rm(pn)
char *pn;
{
  if (unlink(pn) == -1) return(0);
  return(1);
}

rmdir(pn)
char *pn;
{
  int pid, status;
  register char *p;

  for (p = pn+strlen(pn); *p != '/'; p--);
  *p = '\0';
  if (access(pn, 02) == -1) {
    message(21);
    *p = '/';
    return(0);
  }
  *p = '/';
  if ((pid = fork()) == 0) {
    execl("/usr/bryte/bin/rmdir", "fsadm", pn, NULL);
    panic("Can't execute rmdir");
  }
  while (wait(&status) != pid);
  if (status) message(status>>8, pn);
  return(!status);
}

short changemode(fd, fn, m)
int fd;
char *fn;
register short m;
{
  char *ms, c, buf[40], *mkmode();
  int n;
  register short mask;

  print("\033:0;0m\033:%d;%dd", 20*FW, 6*FH);
  print("\033[2;2H%s", fn);
  print("\033:135;10m");
  print("\033:165;10;;1d\033:170;15;;1d");
  print("\033:170;30;;1d\033:165;35;;1d");
  print("\033:135;35;;1d\033:130;30;;1d");
  print("\033:130;15;;1d\033:135;10;;1d");
  print("\033:142;15m\033:1HOK");
  flush(fd);
  while (1) {
    ms = mkmode(m);
    print("\033:8;8m\033:1H%s", ms);
    flush(fd);
    read(fd, &c, 1);
    if (c == ' ') return(m);
    n = c - 'A';
    mask = 0400 >> n;
    if (mask & m) m &= ~mask;
    else m |= mask;
  }
}

char *mkmode(m)
register short m;
{
  static char prot[] = "rwx";
  static char str[10];
  register unsigned short i;

  for (i = 0; i < 9; i++) {
    if ((0400 >> i) & m) str[i] = prot[i%3];
    else str[i] = '-';
  }
  str[9] = '\0';
  return(str);
}

incwd(ix)
register short ix;
{
  register char c, *p;
  register short neq;

  p = port[POOL].name[ix];
  c = *p;
  *p = '\0';
  neq = strcmp(cwd, port[POOL].path[ix]);
  *p = c;
  return(!neq);
}

lookup(pt, ix)
register short pt, ix;
{
  register short i;

  for (i = 0; i < port[pt].cnt; i++) {
    if (!strcmp(port[POOL].name[ix],port[pt].name[i])) return(i);
  }
  panic("lookup() couldn't find %s", port[POOL].path[ix]);
}
