#include "fsadm.h"


char *alloc(n)
{
  char *p, *malloc();

  if ((p = malloc(n)) == NULL) panic("Out of memory");
  return(p);
}

reset(pt)
register short pt;
{
  register short ix;

  for (ix = 0; ix < port[pt].cnt; ix++) free(port[pt].path[ix]);
  port[pt].off = port[pt].cnt = 0;
}

short insert(pt, pn, fn)
register short pt;
register char *pn, *fn;
{
  char  **realloc(), *alloc(), *strcpy(), *strcat();
  short plen, flen, search();
  register short ix, i;

  if (port[pt].cnt+1 > port[pt].max) {
    port[pt].max += NR;
    port[pt].path = realloc(port[pt].path, port[pt].max*sizeof(char *));
    port[pt].name = realloc(port[pt].name, port[pt].max*sizeof(char *));
  }
  ix = search(fn, pt);
  for (i = port[pt].cnt; i > ix; i--) {
    port[pt].path[i] = port[pt].path[i-1];
    port[pt].name[i] = port[pt].name[i-1];
  }
  plen = strlen(pn);
  flen = strlen(fn);
  port[pt].path[ix] = alloc(plen+flen+1);
  port[pt].name[ix] = port[pt].path[ix]+plen;
  strcpy(port[pt].path[ix], pn);
  strcat(port[pt].path[ix], fn);
  port[pt].cnt++;
  return(ix);
}

extract(pt, ix)
register short pt, ix;
{
  register short i;

  free(port[pt].path[ix]);
  for (i = ix+1; i < port[pt].cnt; i++) {
    port[pt].path[i-1] = port[pt].path[i];
    port[pt].name[i-1] = port[pt].name[i];
  }
  port[pt].cnt--;
}

moveup(pt, off)
register short pt, off;
{
  if (off < NR-1) {
    print("\033:%d;%d;%d;%d;%d;%dr",
      PX+1, PY+1, PX+1, PY+FH+1, PW, (NR-off-1)*FH);
  }
  print("\033:%d;%dm\033:%d;%df", PX+PW, PY+FH, PX+1, PY+1);
}

movedn(pt, off)
register short pt, off;
{
  if (off > 0) {
    print("\033:%d;%d;%d;%d;%d;%dr",
      PX+1, PY+(NR-off)*FH+1, PX+1, PY+(NR-off-1)*FH+1, PW, off*FH);
  }
  print("\033:%d;%dm\033:%d;%df", PX+PW, PY+PH, PX+1, PY+(NR-1)*FH+1);
}

expand(pt, off)
register short pt, off;
{
  if (off < NR-1) {
    print("\033:%d;%d;%d;%d;%d;%dr",
      PX+1, PY+FH+1, PX+1, PY+1, PW, (NR-off-1)*FH);
  }
  print("\033:%d;%dm\033:%d;%df", PX+PW, PY+(NR-off)*FH, PX+1, PY+(NR-off-1)*FH+1);
}

bars(pt)
register short pt;
{
  register short np, head, tail;

  np = PH-50;
  if (port[pt].cnt) {
    head = np * port[pt].off / port[pt].cnt;
    tail = np * (port[pt].cnt - port[pt].off - NR) / port[pt].cnt;
    if (tail < 0) tail = 0;
  }
  else {
    head = 0;
    tail = 0;
  }
  if (head) {
    print("\033:%d;%dm", PX+PW+2, PY+PH-26);
    print("\033:%d;%d;8;1f", PX+PW+18, PY+PH-26-head+1);
    print("\033:%d;%d;;1d", PX+PW+2, PY+PH-26-head+1);
  }
  if (tail) {
    print("\033:%d;%dm", PX+PW+2, PY+27);
    print("\033:%d;%d;8;1f", PX+PW+18, PY+27+tail-1);
    print("\033:%d;%d;;1d", PX+PW+2, PY+27+tail-1);
  }
  print("\033:%d;%dm", PX+PW+2, PY+27+tail);
  print("\033:%d;%df", PX+PW+18, PY+PH-26-head);
}

short search(fn, pt)
register char *fn;
register short pt;
{
  register short ix;

  for (ix = 0; ix < port[pt].cnt; ix++)
    if (strcmp(fn, port[pt].name[ix]) < 0) break;
  return(ix);
}

button()
{
  int c = '1', old_c;

  print("\033:2n");
  flush(STDOUT);
  do {
    old_c = c;
    read(STDIN, &c, 1);
  } while (c != 'P');
  return(old_c == '1');
}
