#include <win/w_macros.h>
#include "fsadm.h"

#define FLAGS I_PMODE | I_LMODE | I_PRESS | I_LZERO


mkwin(x, y, w, h)
register short x, y, w, h;
{
  struct winstruc wd;
  int wfd;

  Winstat(STDIN, &wd);
  if ((wfd = open(WMNTDIR, 2)) == -1) return(-1);
  wd.wp_xorig = wd.wl_xorig += x;
  wd.wp_yorig = wd.wl_yorig += y;
  wd.wp_xsize = wd.wl_xsize = w;
  wd.wp_ysize = wd.wl_ysize = h;
  wd.wp_vxorig = wd.wl_vxorig = 0;
  wd.wp_vyorig = wd.wl_vyorig = 0;
  wd.wp_vxsize = wd.wl_vxsize = w;
  wd.wp_vysize = wd.wl_vysize = h;
  wd.w_border = SLBORDER;
  wd.w_level = 0;
  wd.w_tsig = wd.w_ntsig = wd.w_rsig = wd.w_csig = 0;
  wd.w_flags = PMODE | LMODE | NOCURSOR | LOCK;
  Wincreat(wfd, &wd);
  if (wd.w_rstat != W_OK) return(-1);
  setraw(wfd, ON);
  return(wfd);
}

mkicons()
{
  register short i, pt;
  char s[ICONSEQLEN];

  for (i = 0; i < BKN; i++) {
    sprintf(s, "\033F%d.", i);
    wd_icon(STDIN, BKX, BKY+i*BD, BW, BH, s, I_INVERT);
  }
  for (i = 0; i < BFN; i++) {
    sprintf(s, "\033M%d.", i);
    wd_icon(STDIN, BFX, BFY+i*BD, BW, BH, s, 0);
  }
  for (pt = 0; pt < 3; pt++) {
    sprintf(s, "\033S%d;0.", pt);
    wd_icon(STDIN, PX+PW+2, PY+1, 17, 25, s, 0);
    sprintf(s, "\033S%d;1.", pt);
    wd_icon(STDIN, PX+PW+2, PY+PH-24, 17, 25, s, 0);
    for (i = 0; i < NR; i++) {
      sprintf(s, "\033P%d;%d.", pt, i);
      wd_icon(STDIN, PX+1, PY+PH-(i+1)*FH+1, PW, FH, s, I_INVERT);
    }
  }
}

wd_icon(fd, x, y, w, h, s, f)
int fd;
pix_d x, y, w, h;
char *s;
word f;
{
  struct winicon ic;

  ic.ip_xorig = ic.il_xorig = x;
  ic.ip_yorig = ic.il_yorig = y;
  ic.ip_xsize = ic.il_xsize = w;
  ic.ip_ysize = ic.il_ysize = h;
  strcpy(ic.i_cmdseq, s);
  ic.i_flags = FLAGS | f;
  Winicon(fd, &ic);
  if (ic.i_rstat != W_OK) panic("Can't create icon");
}

goodbye()
{
  Rmicons(STDIN);
  setraw(STDIN, OFF);
  print("\033c");
  flush(STDOUT);
  exit(0);
}

chmodeicons(fd)
int fd;
{
  register short n;
  char seq[2];

  for (n = 0; n < 9; n++) {
    sprintf(seq, "%c", n + 'A');
    wd_icon(fd, 8+n*FW, 8, FW, FH, seq, I_INVERT);
  }
  wd_icon(fd, 130, 10, 40, 25, " ", 0);
}
