/****************************************************************
        mwpp - Converts .abcesam files to .window files

	1.00 85-11-28 ldab/hn: Works (hopefully...)
        by Henrik Norbeck, Luxor Datorer AB

	Files:
	main.c    Contains the main program
	read.c    Contains menu reading functions
	strings.c Contains string printing and string handling
	menu.c    Contains menu handling functions
	mwpp.h    Header file
****************************************************************/

#include <stdio.h>
#include "mwpp.h"

FILE *wd;

char *prog_name;
char usage[]="usage: mwpp [infile] [-w wshppfile] [-o outfile]";
char *path;

char nbuf[13][20], pbuf[13][64], mbuf[13][64];
struct menu_t menu[32];
int n_menus;

char *str[5];                   /* operative pointers */
char buf[256];                  /* file string buffer */
short eof;

char *menu_str[13][4];
int n_mstr[13];
char cbuf[13][8];

main(argc, argv)
int argc;
char **argv;
{
    FILE *abcesam, *fopen();
    register int entries, i, current;
    char *getenv(), *abcesamfile, *wdfile, *outfile;

    prog_name = argv[0];
    i = 1;
    abcesamfile = ".abcesam";
    if (i < argc)
	if (strcmp(argv[i], "-")==0 || *argv[i] != '-')
	    abcesamfile = argv[i++];
    if (*abcesamfile == '-')
	abcesam = stdin;
    else
	if ((abcesam=fopen(abcesamfile, "r"))==NULL)
	    panic("Can't read %s", abcesamfile);

    wdfile = ".abcesam.wd";
    if (i < argc)
	if (*argv[i] != '-')
	    panic(usage);
	else if (strcmp(argv[i], "-w") == 0) {
	    if (++i == argc) panic(usage);
	    wdfile = argv[i++];
	    }
    if (*wdfile == '-')
	wd = stdout;
    else
	if ((wd=fopen(wdfile, "w"))==NULL)
	    panic("Can't write %s", wdfile);

    outfile = ".window";
    if (i < argc)
	if (*argv[i] != '-' || strcmp(argv[i], "-o")!=0 || ++i == argc)
	    panic(usage);
	else
	    outfile = argv[i++];

    if (i < argc)
	panic(usage);

    if (NOT (path = getenv("PATH")))
	panic("No PATH environment variable");

    fprintf(wd, "# Window menu created from a .abcesam file\n\n");
    fprintf(wd, "init:substitute1:menu1\n\n");

    fprintf(wd, "# Mouse substitute keys\n");
    fprintf(wd, "substitute1:init#0:onof#0xfe:mpup#0xa1:mpdo#0xa3:\\\n");
    fprintf(wd, ":mple#0xac:mpri#0xa4:mpul#0xad:mpur#0xa5:mpdl#0xaf:\\\n");
    fprintf(wd, ":mpdr#0xa7:lpup#0xb1:lpdo#0xb3:lple#0xbc:lpri#0xb4:\\\n");
    fprintf(wd, ":lpul#0xbd:lpur#0xb5:lpdl#0xbf:lpdr#0xb7:pcmd#0xcc:\\\n");
    fprintf(wd, ":cwin#0xce:mtxt#0xcd:step#4:lstp#16\n\n");

    fprintf(wd, "# The menu window\n");
    fprintf(wd, "window1:pxor#0:pyor#903:pxsi#768:pysi#121:pvxo#0:\\\n");
    fprintf(wd, "       :pvyo#0:pvxs#768:pvys#121:lxor#896:lyor#47:\\\n");
    fprintf(wd, "       :lxsi#128:lysi#721:lvxo#0:lvyo#0:lvxs#128:\\\n");
    fprintf(wd, "       :lvys#721:bord#0:colr#0:pfnt#0x48:lfnt#0x48:\\\n");
    fprintf(wd, "       :pmod:lmod:ncur:spec\n\n");

    fprintf(wd, "# The menu icons\n");
    fprintf(wd, "icon1:pxor#1:pyor#61:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#661:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon2:pxor#129:pyor#61:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#601:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon3:pxor#257:pyor#61:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#541:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon4:pxor#385:pyor#61:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#481:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon5:pxor#513:pyor#61:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#421:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon6:pxor#641:pyor#61:pxsi#126:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#361:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon7:pxor#1:pyor#1:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#301:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon8:pxor#129:pyor#1:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#241:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon9:pxor#257:pyor#1:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#181:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon10:pxor#385:pyor#1:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#121:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon11:pxor#513:pyor#1:pxsi#127:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#61:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n");
    fprintf(wd, "icon12:pxor#641:pyor#1:pxsi#126:pysi#59:lxor#1:\\\n");
    fprintf(wd, "     :lyor#1:lxsi#126:lysi#59:pmod:lmod:inve:rqst\n\n");

    fprintf(wd, "# The default terminal window\n");
    fprintf(wd, "window2:pxor#24:pyor#420:pxsi#80:pysi#24:pvxo#1:pvyo#1:\\\n");
    fprintf(wd, "       :pvxs#80:pvys#24:lxor#30:lyor#390:lxsi#80:\\\n");
    fprintf(wd, "       :lysi#24:lvxo#1:lvyo#1:lvxs#80:lvys#24:colr#1:\\\n");
    fprintf(wd, "       :bord#2:pfnt#0x48:lfnt#0x48:rsig#0:csig#0:pmod:\\\n");
    fprintf(wd, "       :lmod:stxt:sbox:mbox:hscr:vscr:text:zbox\n\n");

    fprintf(wd, "# The zoomlist\n");
    fprintf(wd, "zoomlist2:plst=I:llst=I:pmod:lmod\n\n");

    /* Pass 1: read names of menus and number of entries in each */
    n_menus = 0;
    eof = (getcolon(abcesam, buf, str) == NULL);	/* Get first line */
    if (eof)
	panic("Bad structure file");
    entries = getmenu(abcesam);
    do {
	if ((find(nbuf[0])) == ERROR) {
	    /* Menu did not exist earlier */
	    strcpy(menu[n_menus].name, nbuf[0]);
	    menu[n_menus].father = ERROR;
	    menu[n_menus++].entries = entries;
	    }
	else
	    panic("%s: Menu declared twice", nbuf[0]);
	if (eof) break;
	entries = getmenu(abcesam);
    } while (1);
    fclose(abcesam);

    /* Pass2: write structure to the .wd file */
    if ((abcesam=fopen(abcesamfile, "r"))==NULL)
	panic("Can't read %s", abcesamfile);
    eof = (getcolon(abcesam, buf, str) == NULL);	/* Get first line */
    if (eof)
	panic("Bad structure file");
    current = 0;
    entries = getmenu(abcesam);
    do {
	/* Print menu header */
        fprintf(wd, "## %s\n", mbuf[0]);
	fprintf(wd, "menu%d:window1:lstring%d:pstring%d",
		current+1, current+1, current+1);
	for (i=1; i<13; i++) {
	    sprintf(cbuf[i], "%d%d%d", current+1, i/10, i%10);
	    fprintf(wd, ":choice%s", cbuf[i]);
	    }
	fprintf(wd, "\n\n");
	pr_pstring(entries, current);
	pr_lstring(entries, current);
	for (i=1; i<13; i++)
	    fprintf(wd, "choice%s:icon%d:action%s\n", cbuf[i], i, cbuf[i]);
	putc('\n', wd);
	pr_actions(entries, current);
	current++;
	if (eof) break;
	entries = getmenu(abcesam);
    } while (1);
    fclose (abcesam);
    fclose (wd);

    if (strcmp(wdfile, "-")!=0) {
	printf("Saved '%s'\n", wdfile);
	execl("/usr/window/bin/wshpp", "wshpp", wdfile, "-o", outfile, NULL);
	panic("Can't execute wshpp");
	}
}

panic(format, str)
char *format, *str;
{
    fprintf(stderr, "%s: ", prog_name);
    fprintf(stderr, format, str);
    putc('\n', stderr);
    exit(1);
}
